<template>
    <div class="expert-list">
        <expert-param-list-item v-for="(settings, key) in config" :key="key"
            :id="key" :ref="key" :config="itemConf(settings, key)" :value="data[key]">
        </expert-param-list-item>
    </div>
</template>

<script>
import { MULTISELECT, SELECT } from '@/constants/ui/details';
import ExpertParamListItem from './ExpertParamListItem';

export default {
    components: {
        ExpertParamListItem,
    },
    props: {
        /**
         * server parameters for the list
         */
        data: {
            type: Object,
            required: false,
        },
        /**
         * config with displaying options for the server parameters
         */
        config: {
            type: Object,
            required: true,
        },
    },
    beforeCreate() {
        if (!this.$router.fromLoginPage && !this.$router.isFirstPage) {
            this.$store.commit('experts/clearEditedParams');
            this.$store.commit('blockSubmit', null);
            this.$store.commit('setValidationMessages', { data: {}, clearOld: true });
        }
    },
    computed: {
        itemConf: vm => (conf, key) => {
            const resConf = { ...conf };
            if (conf.defaultTemplate) { // generate default value from data prop
                const templateParams = conf.defaultTemplate.match(/[^%%]\w+(?=%)/gi);
                let resultStr = conf.defaultTemplate;
                if (templateParams && templateParams.length) {
                    templateParams.forEach((paramKey) => {
                        const re = new RegExp(`%${paramKey}%`, 'g');
                        resultStr = resultStr.replace(re, vm.data[paramKey]);
                    });
                }
                resConf.defaultValue = resultStr.toLowerCase();
            }
            if ([MULTISELECT, SELECT].includes(conf.type)) { // generate dictionary
                resConf.dictionaryArray = vm.$store.getters['experts/dictionaryArray'](key);
            }
            if (conf.inputAction && conf.inputAction.routeParams) { // generate params for API validation request
                const routeParams = Object.keys(conf.inputAction.routeParams).reduce((acc, k) => {
                    acc[k] = vm.data[k];
                    return acc;
                }, {});
                resConf.inputAction = { ...conf.inputAction, routeParams };
            }
            if (conf.route && conf.route.params) { // generate router-link with server params
                const params = Object.entries(conf.route.params).reduce((acc, [k, v]) => {
                    acc[k] = vm.data[v];
                    return acc;
                }, {});
                resConf.route = { name: conf.route.name, params };
            }
            return resConf;
        },
    },
    methods: {
        /**
         * Handler to reset edited parameters
         */
        resetEditedParams() {
            Object.values(this.$refs).forEach(([el]) => {
                el.disableEditMode();
            });
        },
    },
};
</script>
